#include "stm32f10x_gpio.h"
typedef struct
{
  /* Functions */
	void (*delay_func)(unsigned int ms);
	
  /* GPIO for I2C pins */
  GPIO_TypeDef * SDA_GPIO;
  GPIO_TypeDef * SCL_GPIO;
  u8 SDA_PIN;
  u8 SCL_PIN;
  
  /* Delay counter value */
  unsigned int DelayValue;
  
  /* I2C address, Register or memory pointer define */
  unsigned char I2C_Address;
  
  /* Register address */
  unsigned char * Reg_Address;
  /* Register address lenght of pointer or Register address depends of reading sequence choosed */
  unsigned char Reg_AddressOrLen;
  
  unsigned char * pBuffer;
  unsigned char pBufferSize;
}I2C_SW_InitStructTypeDef;

typedef enum {
    I2C_SUCCESS = 0,
    I2C_TIMEOUT,
    I2C_ERROR,
    I2C_BUS_BUSY,
    I2C_ACK_OK,
    I2C_ACK_NOT_OK,
    I2C_ADD_NOT_EXIST
} I2C_Result;

I2C_Result SW_I2C_Read_Reg 		(I2C_SW_InitStructTypeDef * I2C_Struct);
I2C_Result SW_I2C_Read_Page 	(I2C_SW_InitStructTypeDef * I2C_Struct);
I2C_Result SW_I2C_Write_Reg 	(I2C_SW_InitStructTypeDef * I2C_Struct);
I2C_Result SW_I2C_Write_Page	(I2C_SW_InitStructTypeDef * I2C_Struct);
I2C_Result SW_I2C_Write_Byte (I2C_SW_InitStructTypeDef * I2C_Struct, unsigned char Reg, unsigned char Value);
